package example;

import java.net.URI;

import org.jboss.remoting3.Channel;
import org.jboss.remoting3.Connection;
import org.jboss.remoting3.Endpoint;
import org.jboss.remoting3.MessageOutputStream;
import org.jboss.remoting3.Remoting;
import org.jboss.remoting3.remote.RemoteConnectionProviderFactory;
import org.xnio.IoFuture;
import org.xnio.OptionMap;
import org.xnio.Options;

public class Client {

	private Endpoint endpoint;
	
	public Client() throws Exception {
		OptionMap optionMap = OptionMap.builder()
				.set(Options.SSL_ENABLED, false)
				.set(Options.SSL_STARTTLS, false)
				.getMap();
		
		endpoint = Remoting.createEndpoint("remote", optionMap);
		endpoint.addConnectionProvider("remote", new RemoteConnectionProviderFactory(), optionMap);

		IoFuture<Connection> connection = endpoint.connect(URI.create("remote://localhost:4447"), optionMap, "bob", "test", "pass".toCharArray());

		
		IoFuture<Channel> channel = connection.get().openChannel("org.jboss.test", optionMap);
		MessageOutputStream stream = channel.get().writeMessage();
		stream.write("GREETINGS".getBytes());
		stream.close();

	}

	public void close() throws Exception {
		endpoint.closeAsync();
	}
		

}